#!/usr/bin/python
# -*- coding:utf-8 -*-

"""
Usage : python getcurrenttrend.py [url of channel]

Download and display activities of VHF channels of Tokyo without options.
If an URL of a channel is specified, display the URLs of bbs for the channel and for most active thread.
"""
import os, string, re, sys
import urllib, tempfile

def output_active_links( url_channel ):
    url_channel = sys.argv[ 1 ]
    file_euc = tempfile.mktemp()
    os.system( "curl %s -s -o %s" % ( url_channel, file_euc ) )
    urls = []
    for line in open( file_euc ).readlines():
        m = re.search( "<a href=\"(.*?)\">", line )
        if m:
            urls.append( m.group( 1 ) )
            pass
        pass
    for address in urls: print address
    file_utf8 = tempfile.mktemp()
    os.unlink( file_euc )
    return urls

def output_current_activities():
    url = "http://epg.2ch.net/tv2chwiki/pukiwiki.php"

    file_euc = tempfile.mktemp()
    file_utf8 = tempfile.mktemp()

    writer = open( file_euc, "w" )
    r_epg = re.compile( "<a href=\"http://epg.2ch.net/subject.cgi" )
    r_end = re.compile( "href=\"./pukiwiki" )
    stream = urllib.urlopen( url )
    line = stream.readline()
    flag_start = False
    while line != "":
        line = line.strip()
        if r_epg.match( line ):
            writer.write( line )
            writer.write( "\n" )
            pass
        if flag_start:
            if r_end.search( line ):
                break
            pass
        line = stream.readline()
        pass
    stream.close()
    writer.close()

    my_dir = os.path.dirname(os.path.abspath(__file__))
    os.system( "%s/nkf --ic=eucJP-ms --oc=utf-8 %s > %s" % ( my_dir, file_euc, file_utf8 ) )
    data = open( file_utf8 ).readlines()
    re_trend = re.compile( "<a href=\"([^\"]+)\">([^<]+)</a>の勢い[^<]*(<B>)?<span[^>]+>\\s*(\\d+)[^<]+</span>(</B>)?[^<]+<a[^>]*>([^<]+)</a>" )
    for line in data:
        m = re_trend.search( line )
        if m:
            cname = m.group( 2 )
            hits  = m.group( 4 )
            churl = m.group( 1 )
            prog  = m.group( 6 )
            print "%s,%s,%s" % ( cname, hits, churl )
            pass
        pass

    os.unlink( file_euc )
    os.unlink( file_utf8 )
    return

if __name__ == "__main__":
    if len( sys.argv ) > 1 and sys.argv[ 1 ].find( "http://" ) >= 0:
        output_active_links( sys.argv[ 1 ] )
    else:
        output_current_activities()
        pass
    pass

